/* symtab.h   The GPLBASIC interpreter
   Copyright (C) 1997 L.C. Benschop, Eindhoven, the Netherlands
   */

typedef struct symrecord {
  unsigned char * name;
  struct symrecord * next;
  union {
    void *p;
    long l;
    double d;
  } contents;
  unsigned char type; 
} VARSYM;
/* meaning of type field. 
 bit 7: function/subroutine. 
 bit 6: array.
 bit 2-0: type TY_PLAIN, TY_INT .. TY_DOUBLE, TY_VOID 
  */ 


typedef struct labrecord {
  union {
    unsigned char * name;
    unsigned int num;
  } id;
  struct labrecord * next;
  void *contents;
  unsigned char flags; /* bit0: alphanumeric, bit1: resolved */
} LABSYM;


void clear_symtabs(void);

LABSYM* look_label(void);
VARSYM* look_var(void);
void check_unresolved(void);
void list_vars(void);

